package simple;


import org.simpleframework.xml.Root;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import java.util.List;
import java.util.ArrayList;

@Root(name="Person")
public class PersonRule extends BaseRule implements IRule  {


    /**
     * Serialize the service object to XML
     *
     * @return XML string
     */
    public String toXML() {
        return super.toXML();
    }

    @Element
    private String name;
    @Element
    private int age;
    @Element
    private String occupation;

    @ElementList
    private List<Account> accounts;


    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }


    public String getOccupation() {
        return occupation;
    }

    public void setOccupation(String occupation) {
        this.occupation = occupation;
    }


    public List<Account> getAccounts() {
        return accounts;
    }

    public void setAccounts(List<Account> accounts) {
        this.accounts = accounts;
    }

    public static void main(String args[]) {
        PersonRule person = new PersonRule();
        person.setName("Jackson");
        person.setAge(32);
        person.setOccupation("Programmer");

        List<Account> accounts = new ArrayList<Account>(2);
        Account account = new Account();
        account.setAccountNo("1234");
        account.setPassword("pass1");
        accounts.add(account);

        account = new Account();
        account.setAccountNo("4567");
        account.setPassword("pass2");
        accounts.add(account);

        person.setAccounts(accounts);

        String xmlString = person.toXML();
        System.out.println(xmlString);

        PersonRule newPerson = (PersonRule)BaseRule.fromXML(xmlString, PersonRule.class);

        System.out.println(newPerson.getName());
        System.out.println(newPerson.getAge());
        System.out.println(newPerson.getOccupation());
        for (Account acc : newPerson.getAccounts()) {
            System.out.println(acc.getAccountNo());
            System.out.println(acc.getPassword());
        }

    }
}
